# WF-PmAPI


### Paquets 
- NSwag.AspNetCore <br>
- Moq

🟨 En cours / ✅ Fait / ❌ Pas fait

### Critères Entity Framework

niveau | description | coeff | jalon | État
--- | --- | --- | --- | ---
☢️ | Le dépôt doit être accessible par l'enseignant | ☢️ | J1  | ✅
☢️ | un .gitignore doit exister au premier push | ☢️ | J1 | ✅
🎬 | les *projets* et les tests compilent | 1 | J1 & J2 | ✅
🎬 | le projet et le tests s'exécutent sans bug (concernant la partie persistance) | 3 | J1 & J2 | ✅
🟢 | Transcription du modèle : Modèle vers entités (et inversement) | 2 | J1 | ✅
🟢 | Requêtes CRUD simples (sur une table) | 1 | J1 | ✅
🟢 | Utilisation de LINQ to Entities | 2 | J1 | ✅
🟡 | Injection / indépendance du fournisseur | 1 | J1 | ✅
🟡 | Requêtes CRUD sur des données complexes (images par exemple) | 2 | J1 | ✅
🟢 | Tests - Appli Console | 1 | J1 |  ✅
🟢 | Tests - Tests unitaires (avec SQLite in memory) | 2 | J1 | ❌
🟢 | Tests - Données stubbées et/ou Moq | 1 | J1 | ✅
🟡 | CI : build, tests, Sonar (doc?) | 1 | J1 | ❌
🟡 | Utilisation de relations (One-to-One, One-to-Many, Many-to-Many) (+ mapping, TU, Requêtes) | 4 | J1 | ✅
🟢 | Liens avec le web service | 2 | J1 | ✅
🟡 | Utilisation d'un *Logger* | 1 | J1 | ❌ 
🟡 | Déploiement | 4 | J2 | ❌
🔴 | Unit of Work❌ / Repository✅ + extras (héritage, accès concurrents...) | 8 | J2 | 🟨
🟢 | Utilisation dans le projet | 2 | J2 | ❌
🟢 | mon dépôt possède un readme qui apporte quelque chose... | 2 | J2 | ✅


### Critères Web API

niveau | description | coeff | jalon | État
--- | --- | --- | --- | ---
☢️ | Le dépôt doit être accessible par l'enseignant | ☢️ | J1 | ✅
☢️ | un .gitignore doit exister au premier push | ☢️ | J1 | ✅
🎬 | les *projets* et les tests compilent | 1 | J1 & J2 | ✅
🎬 | le projet et le tests s'exécutent sans bug (concernant la partie web api) | 4 | J1 & J2 | ✅
🟢 | Modèle <-> DTO | 1 | J1 | ❌
🟢 | Entities <-> DTO | 1 | J1 | ✅
🟡 | Authentification | 4 | J1 |
🟢 | Requêtes GET, PUT, POST, DELETE sur des données simples (1 seul type d'objet en retour, propriétés de types natifs) | 2 | J1 | ✅
🟡 | Pagination & filtrage | 2 | J1 | ✅
🟢 | Injection de service | 2 | J1 | ✅
🟡 | Requêtes GET, PUT, POST, DELETE sur des données complexes (plusieurs données complexes en retour) | 4 | J1 | 🟨
🟢 | Tests - Appli Console (consommation des requêtes) | 4 | J1 | 🟨
🟢 | Tests - Tests unitaires (avec Stub et/ou Moq) | 2 | J1 | ❌
🟡 | CI : build, tests, Sonar, Documentation (en particulier Swagger avec exemples...) | 1 | J1 | ❌
🟢 | Liens avec la persistance en base de données | 4 | J1 | ✅
🟡 | Utilisation d'un *Logger* | 1 | J1 | ❌
🟡 | Déploiement | 4 | J2 | ❌
🟡 | Utilisation dans le projet | 4 | J2 | ❌
🎬 | mon dépôt possède un readme qui apporte quelque chose... | 1 | J2 | ✅

