﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Entity;
using DTO;
using System.Reflection.Metadata;

namespace Dto2Entities
{
    public static class Extention
    {
        // --------------------------- ToDto --------------------------- \\

        public static CharacterDTO ToDto(this Character item)
        {
            if (item == null) return null;
            CharacterDTO character = new CharacterDTO();
            character.Id = item.Id;
            character.Name = item.Name;
            character.imagePath = item.Images.ImgPath;
            return character;
        }

        public static List<CharacterDTO> ToDto(this List<Character> item)
        {
            List<CharacterDTO> characterDTOs = new List<CharacterDTO>();
            foreach (Character character in item)
            {
                characterDTOs.Add(character.ToDto());
            }
            return characterDTOs;
        }

        public static CommentaryDTO ToDto(this Commentary item)
        {
            if (item == null) return null;
            CommentaryDTO commentary = new CommentaryDTO();
            commentary.Id = item.Id;
            commentary.Date = item.DateCommentary;
            commentary.Comment = item.Comment;
            commentary.User = item.User.UserName;
            commentary.ImagePath = item.User.Images.ImgPath;
            return commentary;
        }

        public static List<CommentaryDTO> ToDto(this List<Commentary> item)
        {
            List<CommentaryDTO> commentaryDTOs = new List<CommentaryDTO>();
            foreach (Commentary commentary in item)
            {
                commentaryDTOs.Add(commentary.ToDto());
            }
            return commentaryDTOs;
        }

        // Surement a refaire car Faoirite Entity modifier sur branche EF
        public static FavoriteDTO ToDto(this Favorite item)
        {
            if (item == null) return null;
            FavoriteDTO favorite = new FavoriteDTO();
            favorite.IdUser = item.IdUsers;
            favorite.IdQuote = item.IdQuote;
            return favorite;
        }

        public static List<FavoriteDTO> ToDto(this List<Favorite> item)
        {
            List<FavoriteDTO> favoriteDTOs = new List<FavoriteDTO>();
            foreach (Favorite favorite in item)
            {
                favoriteDTOs.Add(favorite.ToDto());
            }
            return favoriteDTOs;
        }

        public static ImageDTO ToDto(this Images item)
        {
            if (item == null) return null;
            ImageDTO image = new ImageDTO();
            image.IdImage = item.Id;
            image.ImagePath = item.ImgPath;
            return image;
        }

        public static List<ImageDTO> ToDto(this List<Images> item)
        {
            List<ImageDTO> imageDTOs = new List<ImageDTO>();
            foreach (Images images in item)
            {
                imageDTOs.Add(images.ToDto());
            }
            return imageDTOs;
        }

        public static QuestionDTO ToDto(this Question item)
        {
            if (item == null) return null;
            QuestionDTO question = new QuestionDTO();
            question.Id = item.Id;
            question.Question = item.Text;
            question.AnswerA = item.AnswerA;
            question.AnswerB = item.AnswerB;
            question.AnswerC = item.AnswerC;
            question.AnswerD = item.AnswerD;
            question.CorrectAnswer = item.CorrectAnswer;
            return question;
        }

        public static List<QuestionDTO> ToDto(this List<Question> item)
        {
            List<QuestionDTO> questionDTOs = new List<QuestionDTO>();
            foreach (Question question in item)
            {
                questionDTOs.Add(question.ToDto());
            }
            return questionDTOs;
        }

        public static QuizDTO ToDto(this Quiz item)
        {
            if (item == null) return null;
            QuizDTO quiz = new QuizDTO();
            quiz.Id = item.Id;
            quiz.NbQuestion = item.NbQuestion;
            quiz.Title = item.Title;
            quiz.ImagePath = item.Images.ImgPath;
            return quiz;
        }

        public static List<QuizDTO> ToDto(this List<Quiz> item)
        {
            List<QuizDTO> quizDTOs = new List<QuizDTO>();
            foreach (Quiz quiz in item)
            {
                quizDTOs.Add(quiz.ToDto());
            }
            return quizDTOs;
        }

        // Surement a refaire car QuizQuestion Entity modifier sur branche EF
        public static QuizQuestionDTO ToDto(this QuizQuestion item)
        {
            if (item == null) return null;
            QuizQuestionDTO quizQuestion = new QuizQuestionDTO();
            quizQuestion.IdQuiz = item.IdQuiz;
            quizQuestion.IdQuestion = item.IdQuestion;
            return quizQuestion;
        }

        public static List<QuizQuestionDTO> ToDto(this List<QuizQuestion> item)
        {
            List<QuizQuestionDTO> quizQuestionDTOs = new List<QuizQuestionDTO>();
            foreach (QuizQuestion quizQuestion in item)
            {
                quizQuestionDTOs.Add(quizQuestion.ToDto());
            }
            return quizQuestionDTOs;
        }

        public static QuoteDTO ToDto(this Quote item)
        {
            if (item == null) return null;
            QuoteDTO quote = new QuoteDTO();
            quote.Id = item.Id;
            quote.Content = item.Content;
            quote.DateSource = item.Source.Year;
            quote.Character = item.Character.Name;
            quote.TitleSource = item.Source.Title;
            quote.Langage = item.Langage.ToDto();
            quote.ImagePath = item.Character.Images.ImgPath;
            quote.Like = item.Likes;
            quote.Type = item.Source.TypeSrc.ToDto();
            quote.IsValide = item.IsValid;
            return quote;
        }

        public static List<QuoteDTO> ToDto(this List<Quote> item)
        {
            List<QuoteDTO> quoteDTOs = new List<QuoteDTO>();
            foreach (Quote quote in item)
            {
                quoteDTOs.Add(quote.ToDto());
            }
            return quoteDTOs;
        }

        public static SourceDTO ToDto(this Source item)
        {
            if (item == null) return null;
            SourceDTO source = new SourceDTO();
            source.Id = item.Id;
            source.Date = item.Year;
            source.Title = item.Title;
            source.Type = item.TypeSrc.ToDto();
            return source;
        }

        public static List<SourceDTO> ToDto(this List<Source> item)
        {
            List<SourceDTO> sourceDTOs = new List<SourceDTO>();
            foreach (Source source in item)
            {
                sourceDTOs.Add(source.ToDto());
            }
            return sourceDTOs;
        }

        public static UserDTO ToDto(this Users item)
        {
            if (item == null) return null;
            UserDTO user = new UserDTO();
            user.Id = item.Id;
            user.Pseudo = item.UserName;
            user.Password = item.Password;
            user.Email = item.Email;
            user.date = item.Created;
            user.ImageProfil = item.Images.ImgPath;
            return user;
        }

        public static List<UserDTO> ToDto(this List<Users> item)
        {
            List<UserDTO> users = new List<UserDTO>();
            foreach (Users user in item)
            {
                users.Add(user.ToDto());
            }
            return users;
        }

        public static TypeLangageDTO ToDto(this LangEnum item)
        {
            switch (item)
            {
                case LangEnum.vf: return TypeLangageDTO.vf;
                case LangEnum.vo: return TypeLangageDTO.vo;
                default: return TypeLangageDTO.vo;
            }
        }

        public static TypeSrcEnumDTO ToDto(this TypeSrcEnum item)
        {
            switch (item)
            {
                case TypeSrcEnum.movie: return TypeSrcEnumDTO.movie;
                case TypeSrcEnum.book: return TypeSrcEnumDTO.book;
                case TypeSrcEnum.series: return TypeSrcEnumDTO.serie;
                case TypeSrcEnum.videogame: return TypeSrcEnumDTO.videogame;
                default: return TypeSrcEnumDTO.movie;
            }
        }

        // --------------------------- ToEntity --------------------------- \\


        public static Character ToEntity(this CharacterDTO item)
        {
            if (item == null) return null;
            Character character = new Character();
            character.Id = item.Id;
            character.Name = item.Name;
            character.Images = new Images();
            character.Images.ImgPath = item.imagePath ;
            return character;
        }

        public static List<Character> ToEntity(this List<CharacterDTO> item)
        {
            List<Character> characters = new List<Character>();
            foreach (CharacterDTO character in item)
            {
                characters.Add(character.ToEntity());
            }
            return characters;
        }

        public static Commentary ToEntity(this CommentaryDTO item)
        {
            if (item == null) return null;
            Commentary commentary = new Commentary();
            commentary.Id = item.Id;
            commentary.DateCommentary = item.Date;
            commentary.Comment = item.Comment;
            commentary.User = new Users();
            commentary.User.UserName = item.User;
            commentary.User.Images = new Images();
            commentary.User.Images.ImgPath = item.ImagePath;
            return commentary;
        }

        public static List<Commentary> ToEntity(this List<CommentaryDTO> item)
        {
            List<Commentary> commentarys = new List<Commentary>();
            foreach (CommentaryDTO commentary in item)
            {
                commentarys.Add(commentary.ToEntity());
            }
            return commentarys;
        }

        // Surement a refaire car Faoirite Entity modifier sur branche EF
        public static Favorite ToEntity(this FavoriteDTO item)
        {
            if (item == null) return null;
            Favorite favorite = new Favorite();
            favorite.IdUsers = item.IdUser;
            favorite.IdQuote = item.IdQuote;
            return favorite;
        }

        public static List<Favorite> ToEntity(this List<FavoriteDTO> item)
        {
            List<Favorite> favorites = new List<Favorite>();
            foreach (FavoriteDTO favorite in item)
            {
                favorites.Add(favorite.ToEntity());
            }
            return favorites;
        }

        public static Images ToEntity(this ImageDTO item)
        {
            if (item == null) return null;
            Images image = new Images();
            image.Id = item.IdImage;
            image.ImgPath = item.ImagePath;
            return image;
        }

        public static List<Images> ToEntity(this List<ImageDTO> item)
        {
            List<Images> images = new List<Images>();
            foreach (ImageDTO image in item)
            {
                images.Add(image.ToEntity());
            }
            return images;
        }

        public static Question ToEntity(this QuestionDTO item)
        {
            if (item == null) return null;
            Question question = new Question();
            question.Id = item.Id;
            question.Text = item.Question;
            question.AnswerA = item.AnswerA;
            question.AnswerB = item.AnswerB;
            question.AnswerC = item.AnswerC;
            question.AnswerD = item.AnswerD;
            question.CorrectAnswer = item.CorrectAnswer;
            return question;
        }
        public static List<Question> ToEntity(this List<QuestionDTO> item)
        {
            List<Question> questions = new List<Question>();
            foreach (QuestionDTO question in item)
            {
                questions.Add(question.ToEntity());
            }
            return questions;
        }

        public static Quiz ToEntity(this QuizDTO item)
        {
            if (item == null) return null;
            Quiz quiz = new Quiz();
            quiz.Id = item.Id;
            quiz.NbQuestion = item.NbQuestion;
            quiz.Title = item.Title;
            quiz.Images.ImgPath = item.ImagePath;
            return quiz;
        }

        public static List<Quiz> ToEntity(this List<QuizDTO> item)
        {
            List<Quiz> quizs = new List<Quiz>();
            foreach (QuizDTO quiz in item)
            {
                quizs.Add(quiz.ToEntity());
            }
            return quizs;
        }

        // Surement a refaire car QuizQuestion Entity modifier sur branche EF
        public static QuizQuestion ToEntity(this QuizQuestionDTO item)
        {
            if (item == null) return null;
            QuizQuestion quizQuestion = new QuizQuestion();
            quizQuestion.IdQuiz = item.IdQuiz;
            quizQuestion.IdQuestion = item.IdQuestion;
            return quizQuestion;
        }

        public static List<QuizQuestion> ToEntity(this List<QuizQuestionDTO> item)
        {
            List<QuizQuestion> quizQuestions = new List<QuizQuestion>();
            foreach (QuizQuestionDTO quizQuestion in item)
            {
                quizQuestions.Add(quizQuestion.ToEntity());
            }
            return quizQuestions;
        }

        public static Quote ToEntity(this QuoteDTO item)
        {
            if (item == null) return null;
            Quote quote = new Quote();
            quote.Id = item.Id;
            quote.Content = item.Content;
            quote.Source = new Source();
            quote.Source.Year = item.DateSource;
            quote.Character = new Character();
            quote.Character.Name = item.Character;
            quote.Source.Title = item.TitleSource;
            quote.Langage = item.Langage.ToEntity();
            quote.Character.Images = new Images();
            quote.Character.Images.ImgPath = item.ImagePath;
            quote.Likes = item.Like;
            quote.Source.TypeSrc = item.Type.ToEntity();
            quote.IsValid = item.IsValide;
            return quote;
        }

        public static List<Quote> ToEntity(this List<QuoteDTO> item)
        {
            List<Quote> quotes = new List<Quote>();
            foreach (QuoteDTO quote in item)
            {
                quotes.Add(quote.ToEntity());
            }
            return quotes;
        }

        public static Source ToEntity(this SourceDTO item)
        {
            if (item == null) return null;
            Source source = new Source();
            source.Id = item.Id;
            source.Year = item.Date;
            source.Title = item.Title;
            source.TypeSrc = item.Type.ToEntity();
            return source;
        }

        public static List<Source> ToEntity(this List<SourceDTO> item)
        {
            List<Source> sources = new List<Source>();
            foreach (SourceDTO source in item)
            {
                sources.Add(source.ToEntity());
            }
            return sources;
        }

        public static Users ToEntity(this UserDTO item)
        {
            if (item == null) return null;
            Users user = new Users();
            user.Id = item.Id;
            user.UserName = item.Pseudo;
            user.Password = item.Password;
            user.Email = item.Email;
            user.Created = item.date;
            user.Images = new Images();
            user.Images.ImgPath = item.ImageProfil;
            return user;
        }

        public static List<Users> ToEntity(this List<UserDTO> item)
        {
            List<Users> users = new List<Users>();
            foreach (UserDTO user in item)
            {
                users.Add(user.ToEntity());
            }
            return users;
        }

        public static LangEnum ToEntity(this TypeLangageDTO item)
        {
            switch (item)
            {
                case TypeLangageDTO.vf: return LangEnum.vf;
                case TypeLangageDTO.vo: return LangEnum.vo;
                default: return LangEnum.vo;
            }
        }

        public static TypeSrcEnum ToEntity(this TypeSrcEnumDTO item)
        {
            switch (item)
            {
                case TypeSrcEnumDTO.movie: return TypeSrcEnum.movie;
                case TypeSrcEnumDTO.book: return TypeSrcEnum.book;
                case TypeSrcEnumDTO.serie: return TypeSrcEnum.series;
                case TypeSrcEnumDTO.videogame: return TypeSrcEnum.videogame;
                default: return TypeSrcEnum.movie;
            }
        }
    }
}