﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Entity
{
    public class Users
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int Id { get; set; }

        [Required]
        [StringLength(50)]
        public string UserName { get; set; }

        [Required]
        [StringLength(50)]
        public string Email { get; set; }

        [Required]
        [StringLength(200)]
        public string Password { get; set; }

        [ForeignKey(nameof(Images))]
        public int IdImage { get; set; }

        [Required]
        [Column("Created", TypeName = "date")]
        public DateTime Created { get; set; }

        public Images Images { get; set; }

        public ICollection<Quote> Quotes { get; set; } = new List<Quote>();

        public ICollection<Quote> Favorite { get; set; } = new List<Quote>();


        //[ForeignKey(nameof(Admin))]
        //public int Idadmin { get; set; }
        //public Admin admin { get; set; }
    }
}
