﻿using DTO;
using Shared;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StubApi
{
    public class QuoteServiceStub : IQuoteService<QuoteDTO>
    {
        private readonly List<QuoteDTO> _quotes;

        public QuoteServiceStub()
        {
            _quotes = new List<QuoteDTO>
            {
                new QuoteDTO{Id=0, Content="Que la force soit avec toi", Character="Obi-Wan", ImagePath="http://image1", TitleSource="Star Wars", DateSource=1977, Like=32, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=1, Content="Je suis ton père", Character="Darth Vader", ImagePath="http://image2", TitleSource="Star Wars", DateSource=1980, Like=120, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=2, Content="Que la vengeance commence", Character="Anakin Skywalker", ImagePath="http://image3", TitleSource="Star Wars: Episode III", DateSource=2005, Like=95, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=3, Content="J'adore l'odeur du napalm au matin", Character="Kilgore", ImagePath="http://image4", TitleSource="Apocalypse Now", DateSource=1979, Like=56, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=4, Content="Je suis Groot", Character="Groot", ImagePath="http://image5", TitleSource="Guardians of the Galaxy", DateSource=2014, Like=200, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=5, Content="La vie est un rêve", Character="Don Quichotte", ImagePath="http://image6", TitleSource="Don Quichotte", DateSource=1605, Like=34, Langage=TypeLangageDTO.vf, Type=TypeSrcEnumDTO.book,IsValide=true},
                new QuoteDTO{Id=6, Content="To infinity and beyond!", Character="Buzz Lightyear", ImagePath="http://image7", TitleSource="Toy Story", DateSource=1995, Like=180, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=7, Content="Je ne suis pas un héros", Character="Bruce Wayne", ImagePath="http://image8", TitleSource="The Dark Knight", DateSource=2008, Like=250, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=8, Content="Je suis le maître du jeu", Character="Jigsaw", ImagePath="http://image9", TitleSource="Saw", DateSource=2004, Like=65, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=9, Content="Liberté, égalité, fraternité", Character="La devise de la France", ImagePath="http://image10", TitleSource="Révolution française", DateSource=1789, Like=300, Langage=TypeLangageDTO.vf, Type=TypeSrcEnumDTO.book,IsValide=true},
                new QuoteDTO{Id=10, Content="Un petit pas pour l'homme, un grand pas pour l'humanité", Character="Neil Armstrong", ImagePath="http://image11", TitleSource="Moon landing", DateSource=1969, Like=500, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.book,IsValide=true},
                new QuoteDTO{Id=11, Content="C'est la vie", Character="Charles", ImagePath="http://image12", TitleSource="French Movie", DateSource=2013, Like=45, Langage=TypeLangageDTO.vf, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=12, Content="Voici Johnny!", Character="Jack Torrance", ImagePath="http://image13", TitleSource="The Shining", DateSource=1980, Like=300, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=13, Content="Je suis un simple serveur", Character="Hannibal", ImagePath="http://image14", TitleSource="The Silence of the Lambs", DateSource=1991, Like=200, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=14, Content="N'attends pas le moment parfait, prends le moment et rends-le parfait", Character="Zig Ziglar", ImagePath="http://image15", TitleSource="Motivation", DateSource=1995, Like=150, Langage=TypeLangageDTO.vf, Type=TypeSrcEnumDTO.book,IsValide=true},
                new QuoteDTO{Id=15, Content="Le seul vrai voyage est de changer de regard", Character="Marcel Proust", ImagePath="http://image16", TitleSource="À la recherche du temps perdu", DateSource=1913, Like=125, Langage=TypeLangageDTO.vf, Type=TypeSrcEnumDTO.book,IsValide=true},
                new QuoteDTO{Id=16, Content="La force sera avec toi, toujours", Character="Obi-Wan Kenobi", ImagePath="http://image17", TitleSource="Star Wars: Episode IV", DateSource=1977, Like=320, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=17, Content="J'ai toujours rêvé d'être un gangster", Character="Henry Hill", ImagePath="http://image18", TitleSource="Goodfellas", DateSource=1990, Like=500, Langage=TypeLangageDTO.vo, Type=TypeSrcEnumDTO.movie,IsValide=true},
                new QuoteDTO{Id=18, Content="Je vous ai compris", Character="De Gaulle", ImagePath="http://image19", TitleSource="Discours de Gaulle", DateSource=1958, Like=250, Langage=TypeLangageDTO.vf, Type=TypeSrcEnumDTO.book,IsValide=true},
                new QuoteDTO{Id=19, Content="Courage, fuyons!", Character="Frédéric", ImagePath="http://image20", TitleSource="Le Pourceau", DateSource=1834, Like=75, Langage=TypeLangageDTO.vf, Type=TypeSrcEnumDTO.book,IsValide=false}
            };
        }

        public async Task<QuoteDTO> AddQuote(QuoteDTO quote)
        {
            _quotes.Add(quote);
            return quote;
        }

        public async Task<PaginationResult<QuoteDTO>> GetAllQuote()
        {
            return new PaginationResult<QuoteDTO>(_quotes.Where(q=>q.IsValide == true).ToList().Count,
                                                0,
                                                _quotes.Count,
                                                _quotes.Where(q => q.IsValide == true).ToList());
        }

        public async Task<PaginationResult<QuoteDTO>> GetAllQuoteLang(int index, int pageSize, int lang)
        {
            TypeLangageDTO langageType = (TypeLangageDTO)lang;

            return new PaginationResult<QuoteDTO>(_quotes.Where(q => q.IsValide = true).ToList().Count,
                                                index,
                                                pageSize,
                                                _quotes.Where(q => q.IsValide == true && q.Langage == langageType ).ToList().Skip(index * pageSize).Take(pageSize).ToList()
                                                );

        }

        public async Task<QuoteDTO> GetDailyQuote(DateOnly date, int lang)
        {
            int nb = _quotes.Where(q => q.Langage == (TypeLangageDTO)lang && q.IsValide == true).Count();
            return _quotes.Where(q => q.Langage == (TypeLangageDTO)lang && q.IsValide == true).ToList().Find(q => q.Id == date.DayNumber%nb) ?? _quotes.Where(q => q.Langage == (TypeLangageDTO)lang && q.IsValide == true).First();
        }

        public async Task<PaginationResult<QuoteDTO>> GetFavorites(int index, int pageSize, int UserId)
        {
            throw new NotImplementedException();
        }

        public async Task<PaginationResult<QuoteDTO>> GetInvalidQuote(int index, int pageSize)
        {
            throw new NotImplementedException();
        }

        public async Task<int> GetLastQuoteId() // JE VOIS PAS L'INTERET
        {
            throw new NotImplementedException();
        }

        public async Task<QuoteDTO> GetQuoteById(int id)
        {
            return _quotes.FirstOrDefault(q => q.Id == id);
        }

        public async Task<PaginationResult<QuoteDTO>> GetSomeQuote(int index, int pageSize)
        {
            return new PaginationResult<QuoteDTO>(_quotes.Where(q => q.IsValide = true).ToList().Count,
                                                index,
                                                pageSize,
                                                _quotes.Where(q => q.IsValide = true).ToList().Skip(index * pageSize).Take(pageSize).ToList()
                                                );
        }

        public async Task<PaginationResult<QuoteDTO>> GetSuggestions(int index, int pageSize, int lang)
        {
            throw new NotImplementedException();
        }

        public async Task<PaginationResult<QuoteDTO>> GetValidQuote(int index, int pageSize)
        {
            throw new NotImplementedException();
        }

        public async Task RemoveQuote(int quoteId)
        {
            _quotes.Remove( GetQuoteById(quoteId).Result );
        }

        public async Task<PaginationResult<QuoteDTO>> SearchByCharacter(string character, int index, int pageSize, int lang)
        {
            throw new NotImplementedException();
        }

        public async Task<PaginationResult<QuoteDTO>> SearchByContent(string content, int index, int pageSize, int lang)
        {
            throw new NotImplementedException();
        }

        public async Task<PaginationResult<QuoteDTO>> SearchBySource(string source, int index, int pageSize, int lang)
        {
            throw new NotImplementedException();
        }

        public async Task UpdateQuote(int quoteId, QuoteDTO quote)
        {
            throw new NotImplementedException();
        }

        public async Task ValidateQuote(int quoteId, bool isValidate)
        {
            throw new NotImplementedException();
        }
        public async Task<PaginationResult<QuoteDTO>> GetInvalidQuote(int index, int pageSize, int lang)
        {
            TypeLangageDTO langageType = (TypeLangageDTO)lang;

            return new PaginationResult<QuoteDTO>(_quotes.Where(q => q.IsValide == false && q.Langage == langageType).ToList().Count,
                                                index,
                                                pageSize,
                                                _quotes.Where(q => q.IsValide == false && q.Langage == langageType).ToList().Skip(index * pageSize).Take(pageSize).ToList()
                                                );
        }
    }
}
